import { AbstractConstructor, Constructor } from "../common/types";
import { InjectionMode } from "./InjectionMode";
import { AbstractProvider } from "./AbstractProvider";
import { IInjector } from "./IInjector";
interface InjectableInfo<T> {
    constructorFn: Constructor<T>;
    mode: InjectionMode;
    dependencies?: {
        ctor: AbstractConstructor<any>;
        required: boolean;
    }[];
    singletonInstance?: T;
}
declare class ServiceProvider {
    private injectableRegistry;
    private providerRegistry;
    private initables;
    getInfo<T>(constructorFn: Constructor<T>): InjectableInfo<T> | undefined;
    register<T>(constructorFn: Constructor<T>, mode?: InjectionMode): ServiceProvider;
    addProvider<T>(baseClass: AbstractConstructor<T>, provider: Constructor<AbstractProvider<T>>): ServiceProvider;
    getInjector(): IInjector;
}
export declare const getServiceProvider: () => ServiceProvider;
export {};
